## gall 1.1

=== debian/changelog ===
gall (1.1-2) unstable; urgency=medium

  * Fix homepage URL to the git server for Gall.

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Thu, 27 Oct 2016 15:21:07 +0900

gall (1.1-1) unstable; urgency=medium

  * Initial packaging of Gall as a separate project.
  * Closes: #840724

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Fri, 14 Oct 2016 10:56:18 +0900

## gall 1.2

=== Makefile ===
all: test

MODULES := gall gall.util gall.ll \
	   gall.repository gall.object gall.commit gall.tag gall.tree
LUA_VER := 5.1

PREFIX ?= /usr/local

INST_BASE := $(PREFIX)
INST_ROOT := $(DESTDIR)$(INST_BASE)/share/lua/$(LUA_VER)
C_INST_ROOT := $(DESTDIR)$(INST_BASE)/lib/lua/$(LUA_VER)

INCS := -I/usr/include/lua$(LUA_VER) -Ilibgit2/build/gall-install/include
OPT := -O0 -g
PIC := -fPIC
WARN := -Wall -Werror
DEFS := 
CFLAGS := $(INCS) $(OPT) $(WARN) $(DEFS) $(PIC) $(CFLAGS)
LIBGIT2_LDEPS ?= -lssl -lssh2 -lrt
LFLAGS := -O1 -g -Llibgit2/build/gall-install/lib -lgit2 $(LIBGIT2_LDEPS) $(LFLAGS)

MOD_FILES := $(patsubst %,%.lua,$(subst .,/,$(MODULES)))

NCPUS := $(shell getconf _NPROCESSORS_ONLN 2>/dev/null || echo 1)
DASH_J := -j $(shell expr \( $(NCPUS) \* 3 \) / 2)

install: cmodule
	mkdir -p $(INST_ROOT)/gall
	for MOD in $(sort $(MOD_FILES)); do \
		cp lib/$${MOD} $(INST_ROOT)/$${MOD}; \
	done
	if test -e lib/gall/ll/git2.so; then \
		mkdir -p $(C_INST_ROOT)/gall/ll; \
		cp lib/gall/ll/git2.so $(C_INST_ROOT)/gall/ll/; \
	fi


LUA := LUA_CPATH="$(shell pwd)/lib/?.so;;" LUA_PATH="$(shell pwd)/lib/?.lua;$(shell pwd)/extras/luacov/src/?.lua;;" lua$(LUA_VER)

cmodule: try-cmodule

try-cmodule:
	-@$(MAKE) --no-print-directory do-cmodule

do-cmodule: lib/gall/ll/git2.so

lib/gall/ll/git2.so: libgit2/build/gall-install-stamp lib/gall/ll/git2.c
	$(CC) $(CFLAGS) lib/gall/ll/git2.c -o $@ -shared $(LFLAGS)

libgit2/build/gall-install-stamp:
	mkdir -p libgit2/build
	cd libgit2/build && cmake -DBUILD_SHARED_LIBS:BOOLEAN=OFF -DCMAKE_INSTALL_PREFIX:PATH=$(shell pwd)/libgit2/build/gall-install -DCMAKE_C_FLAGS=-fPIC ..
	cd libgit2/build && $(MAKE) $(DASH_J)
	echo "DISABLED BECAUSE LIBGIT2 AUTHORS ARE MAD: cd libgit2/build && $(MAKE) test"
	cd libgit2/build && ./libgit2_clar -xonline
	cd libgit2/build && $(MAKE) install DESTDIR=""
	touch $@

clean:
	$(RM) luacov.report.out luacov.report.git2.out luacov.stats.out
	$(RM) -r libgit2/build luagit2/build lib/gall/ll/git2.so

distclean: clean
	find . -name "*~" -delete
	$(RM) libgit2/tests-clar/clar.h
	$(RM) libgit2/tests-clar/clar_main.c

.PHONY: example
example:
	$(LUA) example/gall-example.lua

.PHONY: test
test: cmodule
	@$(RM) luacov.stats.out; \
	ERR=0; \
	for MOD in $(sort $(MODULES)); do \
		echo -n "$${MOD}: "; \
		$(LUA) test/test-$${MOD}.lua; \
		test "x$$?" = "x0" || ERR=1; \
	done; \
	$(LUA) extras/luacov/src/bin/luacov -X luacov. -X test. $(MODULES); \
	mv luacov.report.out luacov.report.git2.out; \
	for MOD in $(sort $(MODULES)); do \
		echo -n "$${MOD} [no git2]: "; \
		GALL_DISABLE_GIT2=1 $(LUA) test/test-$${MOD}.lua; \
		test "x$$?" = "x0" || ERR=1; \
	done; \
	$(LUA) extras/luacov/src/bin/luacov -X luacov. -X test. $(MODULES); \
	exit $$ERR
	@echo -n "Allowing use of luagit2 saves "; \
	PRE=$$(grep sp.spawn_simple luacov.report.git2.out | awk '{print $$1}'); \
	POST=$$(grep sp.spawn_simple luacov.report.out | awk '{print $$1}'); \
	NORM=$$((POST - PRE)); \
	echo -n $$((NORM - PRE)) / $${NORM}; \
	echo " calls out to git executable during test suite."

.PHONY: interactive
interactive:
	$(LUA) -e'gall=require"gall"' -i

=== debian/changelog ===
gall (1.2-1) unstable; urgency=medium

  * New upstream version, uses git_libgit2_init()

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Thu, 26 Jan 2017 00:00:16 +0000

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --buildsystem=lua --with lua

override_dh_auto_build:
	dh_auto_build
	ldoc --date $(SOURCE_DATE_EPOCH) .

override_dh_auto_clean:
	dh_auto_clean
	$(RM) -r html

## gall 1.3

=== Makefile ===
all: test

MODULES := gall gall.util gall.ll \
	   gall.repository gall.object gall.commit gall.tag gall.tree
LUA_VER := 5.2

PREFIX ?= /usr/local

INST_BASE := $(PREFIX)
INST_ROOT := $(DESTDIR)$(INST_BASE)/share/lua/$(LUA_VER)
C_INST_ROOT := $(DESTDIR)$(INST_BASE)/lib/lua/$(LUA_VER)

ifeq ($(shell pkg-config --exists libgit2 && echo YAY),YAY)
HAVE_GIT2 := YES
GIT2_CFLAGS := $(shell pkg-config --cflags libgit2)
GIT2_LIBS := $(shell pkg-config --libs libgit2)
else
HAVE_GIT2 := NO
GIT2_CFLAGS :=
GIT2_LIBS :=
endif

INCS := -I/usr/include/lua$(LUA_VER) $(GIT2_CFLAGS)
OPT := -O0 -g
PIC := -fPIC
WARN := -Wall -Werror
DEFS := 
CFLAGS := $(INCS) $(OPT) $(WARN) $(DEFS) $(PIC) $(CFLAGS)
LFLAGS := -O1 -g $(GIT2_LIBS) $(LFLAGS)

MOD_FILES := $(patsubst %,%.lua,$(subst .,/,$(MODULES)))

NCPUS := $(shell getconf _NPROCESSORS_ONLN 2>/dev/null || echo 1)
DASH_J := -j $(shell expr \( $(NCPUS) \* 3 \) / 2)

install: cmodule
	mkdir -p $(INST_ROOT)/gall
	for MOD in $(sort $(MOD_FILES)); do \
		cp lib/$${MOD} $(INST_ROOT)/$${MOD}; \
	done
	if test -e lib/gall/ll/git2.so; then \
		mkdir -p $(C_INST_ROOT)/gall/ll; \
		cp lib/gall/ll/git2.so $(C_INST_ROOT)/gall/ll/; \
	fi


LUA := LUA_CPATH="$(shell pwd)/lib/?.so;;" LUA_PATH="$(shell pwd)/lib/?.lua;$(shell pwd)/extras/luacov/src/?.lua;;" __GALL_LL_GIT2_BLACKLIST="$(shell lua$(LUA_VER) find-git2)" lua$(LUA_VER) -e "dofile('blacklist-system-git2')"

ifeq ($(HAVE_GIT2),YES)
cmodule: lib/gall/ll/git2.so

lib/gall/ll/git2.so: lib/gall/ll/git2.c
	$(CC) $(CFLAGS) lib/gall/ll/git2.c -o $@ -shared $(LFLAGS)

else
cmodule:
	@echo "Unable to compile C module, libgit2 not found. SKIPPING"
endif

clean:
	$(RM) luacov.report.out luacov.report.git2.out luacov.stats.out
	$(RM) -r lib/gall/ll/git2.so

distclean: clean
	find . -name "*~" -delete

.PHONY: test
test: cmodule
	@$(RM) luacov.stats.out; \
	ERR=0; \
	for MOD in $(sort $(MODULES)); do \
		echo -n "$${MOD}: "; \
		$(LUA) test/test-$${MOD}.lua; \
		test "x$$?" = "x0" || ERR=1; \
	done; \
	$(LUA) extras/luacov/src/bin/luacov -X luacov. -X test. $(MODULES); \
	mv luacov.report.out luacov.report.git2.out; \
	for MOD in $(sort $(MODULES)); do \
		echo -n "$${MOD} [no git2]: "; \
		GALL_DISABLE_GIT2=1 $(LUA) test/test-$${MOD}.lua; \
		test "x$$?" = "x0" || ERR=1; \
	done; \
	$(LUA) extras/luacov/src/bin/luacov -X luacov. -X test. $(MODULES); \
	exit $$ERR
ifeq ($(HAVE_GIT2),YES)
	@echo -n "Allowing use of luagit2 saves "; \
	PRE=$$(grep sp.spawn_simple luacov.report.git2.out | awk '{print $$1}'); \
	POST=$$(grep sp.spawn_simple luacov.report.out | awk '{print $$1}'); \
	NORM=$$((POST - PRE)); \
	echo -n $$((NORM - PRE)) / $${NORM}; \
	echo " calls out to git executable during test suite."
endif

.PHONY: interactive
interactive:
	$(LUA) -e'gall=require"gall"' -i

=== debian/changelog ===
gall (1.3-1build3) focal; urgency=medium

  * No-change rebuild against libgit2-28

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 30 Nov 2019 06:21:53 +0000

gall (1.3-1build2) cosmic; urgency=medium

  * No-change rebuild against latest libgit2

 -- Chris Coulson <chris.coulson@canonical.com>  Wed, 30 May 2018 21:45:19 +0000

gall (1.3-1build1) bionic; urgency=medium

  * No-change rebuild against latest libgit2

 -- Jeremy Bicha <jbicha@ubuntu.com>  Fri, 27 Oct 2017 13:42:59 -0400

gall (1.3-1) unstable; urgency=medium

  * New upstream version

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Wed, 02 Aug 2017 17:35:24 -0400

=== debian/control ===
Source: gall
Section: interpreters
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Daniel Silverstone <dsilvers@digital-scurf.org>
Build-Depends: debhelper (>= 9.20120909~), dh-lua, lua-ldoc, lua-discount,
 lua-luxio, libgit2-dev, git
Standards-Version: 3.9.8
Homepage: https://git.gitano.org.uk/gall.git/

Package: lua-gall
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, git, lua-luxio0
Provides: ${lua:Provides}
XB-Lua-Versions: ${lua:Versions}
Multi-Arch: same
Description: Git Abstraction Layer for Lua
 Gall is a Git abstraction layer for Lua which implements a set of Lua objects
 which can interact with git repositories (via libgit2 where possible).
 .
 Gall allows a Lua program to examine refs and objects, and to fully create
 git commits without needing to create a working tree on disk.

Package: lua-gall-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Documentation for lua-gall
 Gall is a Git abstraction layer for Lua which implements a set of Lua objects
 which can interact with git repositories (via libgit2 where possible).
 .
 Gall allows a Lua program to examine refs and objects, and to fully create
 git commits without needing to create a working tree on disk.
 .
 This package contains the documentation on how to use the Gall library.

=== debian/watch ===
version=3
https://git.gitano.org.uk/gall.git /gall\.git/snapshot/gall-(.+)\.tar.bz2
